// module hu_rs232.h
// serial (RS232) communication under Windows 32 bit
//
// Copyright Dr.E.Huckert 04-2002
// 2017-01-05 added method getErrorString()

#ifndef HU_RS232_DEFINED
#define HU_RS232_DEFINED
#include <windows.h>

class HU_RS232
{
private:
  int      logging    ;
  HANDLE   comm_handle;
  unsigned long baudrate;
  unsigned comno;
  int      writeflag;
  int      sum_retrans;
  int      loc_retrans;
  unsigned maxtimeout;
public:
  HU_RS232(unsigned comno, unsigned long baudrate);
  ~HU_RS232();
  int open_line(int writeflag);
  int close_line();
  unsigned char checksum(char *buf,
                         int lbuf);
  int read_line(char *buf, int lbuf);
  int put_line(char *buf, int lbuf);
  int send_ack(char ack);
  int wait_ack();
  int receive_file(char *fn);
  int send_file(char *fn);
  void set_logging(int flag)
  { this->logging = flag; };
  const char *getErrorString();
  void set_timeout(unsigned val)
  { this->maxtimeout = val; };
};

#endif

